Unit Base;
Interface
Const
   Left  = #75;
   Right = #77;
   Up    = #72;
   Down  = #80;
   Del   = #8;
   Esc   = #27;
   Enter = #13;
   Max = 20;
Type
 MenuStr = array [1..max] of string;
 Function Menu(name : string;a : MenuStr;num : byte;size : byte) : Byte;
 Function FileList(s : PChar;size : byte) : string;
 Procedure Init(mode : integer;path : string);
 Procedure Input(text : string;var value : Word;size : byte);
 Procedure InputRel(text : string;var value : Real;size : byte);
 Procedure ReadStr(text : string;var s : string;size : byte);
 Procedure TDisplay(ScanLine: Word);
 Procedure ClearBuffer;
 Procedure AnaliseComputer;
 Procedure Title;
 Procedure SnowGo;
Implementation
 Uses Graph,Crt,Dos,WinDos;
 Type
  Registers = record
    case Integer of
    0: (AX, BX, CX, DX, BP, SI, DI, DS, ES, Flags: Word);
    1: (AL, AH, BL, BH, CL, CH, DL, DH: Byte);
  end;
 Var
  keyflag : Byte absolute $40:$17;
{}
 Procedure Init;
  var
   Gd,Gm : integer;
  begin
   case mode of
    1 : begin       {VGA 640x480x016}
         Gd:=9;Gm:=2;
         InitGraph(Gd,Gm,path);
        end;
    2 : begin       {VGA 640x480x256}
         Gd:=InstallUserDriver('svga256', nil);Gm:=2;
         InitGraph(Gd,Gm,path);
        end;
    3 : begin
         Gd := EGA; Gm := EGAHI;
         InitGraph(Gd, Gm, '');
        end;
   end;
  end;
{}
  Procedure TDisplay;
   var
    OldReg: Byte;
   begin
    if ScanLine > 256 then
     begin
      Port[$3D4] := $07;
      OldReg := Port[$3D5];
      Port[$3D5] := OldReg or $10;
      Port[$3D4] := $09;
      OldReg := Port[$3D5];
      if (OldReg or $40) <> 0 then Port[$3D5] := OldReg and $BF;
      Dec(ScanLine, 256);
     end
      else
     begin
      Port[$3D4] := $07;
      OldReg := Port[$3D5];
      PortW[$3D4] := ((OldReg and $EF) shl 8) or $07;
      Port[$3D4] := $09;
      OldReg  := Port[$3D5];
      PortW[$3D4] := ((OldReg and $BF) shl 8) or $09;
     end;
    PortW[$3D4] := (ScanLine shl 8) or $18;
   end;
{}
 Function Menu;
  var
   x,y,xk,yk : integer;
   i,j,k : integer;
   th,tw : integer;
   Pointer : Byte;
   XY : array[1..max] of record
                          xn,yn,xk,yk : integer;
                         end;
   key : char;
   p : system.pointer;
  begin
   SetTextStyle(8,0,size);
   x:=(GetMaxX div 2)-100;
   y:=40;
   th:=TextHeight(#86)+5;
   tw:=TextWidth(#86);
   xk:=x+tw;yk:=y+th;
   SetFillStyle(1,7);
   for i:=1 to num do Inc(yk,th);
   j:=0;k:=j;
   for i:=1 to num do
    begin
     k:=TextWidth(a[i]);
     if (k>j)then j:=k;
    end;
   GetMem(p,imagesize(x,y,x+j+15,y+yk-10));
   GetImage(x,y,x+j+15,y+yk-10,p^);
   Bar(x,y,x+j+15,y+yk-10);
   SetColor(1);
   Rectangle(x,y,x+j+15,y+yk-10);
   Rectangle(x+5,y+5,x+j+15-5,y+yk-10-5);
   SetTextStyle(5,0,4);OutTextXY(x+10,y-10,name);Line(x+5,y+TextHeight(name),x+j+15-5,y+TextHeight(name));
   SetColor(4);SetTextStyle(8,0,size);
   yk:=y+th;
   for i:=1 to num do
    begin
     OutTextXY(xk,yk,a[i]);
     XY[i].xn:=xk;
     XY[i].yn:=yk;
     Inc(yk,th);
     XY[i].xk:=xk+170;
     XY[i].yk:=yk;
    end;
   Pointer:=1;
   SetColor(1);OutTextXY(xy[pointer].xn,xy[pointer].yn,a[pointer]);
   repeat
    key:=readkey;if key=#0 then key:=readkey;
    case key of
     Up : begin
           SetColor(4);OutTextXY(xy[pointer].xn,xy[pointer].yn,a[pointer]);
           Dec(Pointer);if (Pointer<1)then Pointer:=num;
           SetColor(1);OutTextXY(xy[pointer].xn,xy[pointer].yn,a[pointer]);
          end;
     Down : begin
             SetColor(4);OutTextXY(xy[pointer].xn,xy[pointer].yn,a[pointer]);
             Inc(Pointer);if (Pointer>num)then Pointer:=1;
             SetColor(1);OutTextXY(xy[pointer].xn,xy[pointer].yn,a[pointer]);
            end;
    end;
   until (key = Enter);
   PutImage(x,y,p^,0);
   FreeMem(p,imagesize(x,y,x+j+15,y+yk-10));
   Menu:=Pointer;
  end;
{}
 Function FileList;
  var
   i : integer;
   a : MenuStr;
   DirInfo : TSearchRec;
  begin
   FindFirst(s, faArchive, DirInfo);
   i:=0;
    while (DosError = 0)and(i<max) do
     begin
      Inc(i);
      a[i]:=DirInfo.Name;
      FindNext(DirInfo);
     end;
   i:=Menu('File List',a,i,size);
   FileList:=a[i];
  end;
{}
 Procedure Input;
  const
   len = 5;
  var
   x,y,w,code : integer;
   i,j : integer;
   th,tw : integer;
   key : char;
   s : string[len];
  begin
   x:=10;y:=10;
   SetFillStyle(1,7);
   SetTextStyle(8,0,size);
   th:=TextHeight(#86);
   tw:=TextWidth(#86);
   w:=TextWidth(text);
   Bar(x,y,x+w+th*len,y+2*th);
   SetColor(1);Rectangle(x,y,x+w+th*len,y+2*th);Rectangle(x+5,y+5,x+w+th*len-5,y+2*th-5);
   OutTextXY(x+7,y+5,text);
   i:=1;s:='';
   repeat
    key:=readkey;if key=#0 then key:=readkey;
    case key of
     #48..#57 : begin
                 if (i>len)then continue;
                 s:=s+key;
                 OutTextXY(x+w+7+i*tw,y+5,key);
                 inc(i);
                end;
     #8 : begin
           if (i<1)then continue;
           delete(s,length(s)-1,1);
           dec(i);
           Bar(x+w+7+i*tw,y+10,x+w+7+(i+1)*tw,y+5+th);
          end;
    end;
   until (key = Enter);
   val(s,value,code);
  end;
{}
 Procedure InputRel;
  const
   len = 5;
  var
   x,y,w,code : integer;
   i,j : integer;
   th,tw : integer;
   key : char;
   s : string[len];
  begin
   x:=10;y:=10;
   SetFillStyle(1,7);
   SetTextStyle(8,0,size);
   th:=TextHeight(#86);
   tw:=TextWidth(#86);
   w:=TextWidth(text);
   Bar(x,y,x+w+th*len,y+2*th);
   SetColor(1);Rectangle(x,y,x+w+th*len,y+2*th);Rectangle(x+5,y+5,x+w+th*len-5,y+2*th-5);
   OutTextXY(x+7,y+5,text);
   i:=1;s:='';
   repeat
    key:=readkey;if key=#0 then key:=readkey;
    case key of
     #46,#48..#57 : begin
                     if (i>len)then continue;
                     s:=s+key;
                     OutTextXY(x+w+i*tw,y+5,key);
                     inc(i);
                    end;
     #8 : begin
           if (i<1)then continue;
           delete(s,length(s)-1,1);
           dec(i);
           Bar(x+w+7+i*tw,y+10,x+w+(i+1)*tw,y+5+th);
          end;
    end;
   until (key = Enter);
   val(s,value,code);
  end;
{}
 Procedure ReadStr;
  const
   len = 12;
  var
   x,y,w,code : integer;
   i,j : integer;
   th,tw : integer;
   key : char;
  begin
   x:=10;y:=10;
   SetFillStyle(1,7);
   SetTextStyle(8,0,size);
   th:=TextHeight(#86);
   tw:=TextWidth(#86);
   w:=TextWidth(text);
   Bar(x,y,x+w+th*len,y+2*th);
   SetColor(1);Rectangle(x,y,x+w+th*len,y+2*th);Rectangle(x+5,y+5,x+w+th*len-5,y+2*th-5);
   OutTextXY(x+7,y+5,text);
   i:=1;
   repeat
    key:=readkey;if key=#0 then key:=readkey;
    case key of
     #32..#122 : begin
                 if (i>len)then continue;
                 s:=s+key;
                 OutTextXY(x+w+7+i*tw,y+5,key);
                 inc(i);
                end;
     #8 : begin
           if (i<1)then continue;
           delete(s,length(s)-1,1);
           dec(i);
           Bar(x+w+7+i*tw,y+10,x+w+7+(i+1)*tw,y+15+th);
          end;
    end;
   until (key = Enter);
  end;
{}
 Procedure Title;
  var
   i,j,x,y : integer;
   a,q,w : integer;
  {$F+}
   function TestDetect: Integer; begin TestDetect := 1; end;
  {$F-}
  begin
   for i:=1 to 63 do
     begin SetRGBPalette(i,i,0,0);SetFillStyle(1,i);Bar(0,0,GetMaxX,GetMaxY);end;
   for i:=64 to 127 do
     begin SetRGBPalette(i,63-i,i-64,0);SetFillStyle(1,i);Bar(0,0,GetMaxX,GetMaxY);end;
   for i:=128 to 191 do
     begin SetRGBPalette(i,0,127-i,i-127);SetFillStyle(1,i);Bar(0,0,GetMaxX,GetMaxY);end;
   for i:=191 to 254 do
     begin SetRGBPalette(i,0,0,254-i);SetFillStyle(1,i);Bar(0,0,GetMaxX,GetMaxY);end;
   SetLineStyle(0,0,3);
   for i:=1 to 254 do
    begin setcolor(i);circle(GetmaxX div 2,GetmaxY div 2,i);end;
    for j:=255 downto 1 do
     SetRGBPalette(j,0,0,0);
{   CloseGraph;
   i := InstallUserDriver('SVGA256', @TestDetect);j:=4;
   InitGraph(i, j, '');
   q:=800;w:=200;
   q:=42;a:=63-q;
   SetColor(15);
   SetTextStyle(8,0,6);
   OutTextXY(150,200,'Loading please wait');
   for i:=1 to 42 do
     begin
      SetRGBPalette(i        ,q  +a ,i  +a ,0  +a );
      SetRGBPalette(i+1*(q-1),q-i+a ,q  +a ,0+a   );
      SetRGBPalette(i+2*(q-1),0     +a,q  +a ,i+a );
      SetRGBPalette(i+3*(q-1),0     +a,q-i+a ,q+a );
      SetRGBPalette(i+4*(q-1),i+a   ,0  +a   ,q  +a );
      SetRGBPalette(i+5*(q-1),q  +a ,0  +a ,q-i+a );
     end;
   for i:=1 to GetMaxX do
     begin Setcolor(trunc(i/4));Line(i,0,i,GetMaxY);end;
   ReadLn;}
  end;
{}
 Procedure AnaliseComputer;
  const
   n = 4;
   Temp = 100;
   files : array [1..n] of string[12] =
   ('lcom.chr','scri.chr','egavga.bgi','svga256.bgi');
  var
   a,b : Word;
   k,j,m,e : Word;
   s : string;
   r : TRegisters;
   Time : Longint;
   {}
    Function RightShiftDown : Boolean;
     var
      regs : TRegisters;
     begin
      regs.ah:=2;
      intr($16,regs);
      rightshiftdown:=regs.al and 1=1;
     end;
   {}
    Procedure setnumlock(state:boolean);
     begin
      if state then keyflag:=keyflag or $20 else keyflag:=keyflag and $DF;
     end;
   {}
    Function FilePresent(s : string) : Boolean;
     var
      f : file;
     begin
      Assign(f,s);
      {$I-}
      Reset(f);
      {$I+}
      FilePresent:=(IOResult=0);
     end;
   {}
 begin
   {                            analise system                               }
   Randomize;
   ClrScr;
   TextBackGround(4);
   TextColor(15);
   Write('                         3D Animator v1.0                                       ');
   NormVideo;
   Write('Analising system ');
   for a:=1 to 6 do begin Write('.');Delay(Temp);end;WriteLn;
   if (Mem[$F000:$FFFE] = $FC) then
    begin
     WriteLn('  computer IBM AT : ');
     Port[$70]:=$14;
     a:=Port[$71];
     if a and 1<>0 then
      case (a shr 6)and 3 of
       0 : WriteLn('  Found 1 floppy disk ');
       1 : WriteLn('  Found 2 floppy disks ');
      end;
     if a and 2<>0 then WriteLn('  Found co-processor');
     case (a shr 4)and 3 of
      0 : WriteLn('  Found adapter EGA/VGA');
      1 : WriteLn('  Found color adapter 40x25');
      2 : WriteLn('  Found color adapter 80x25');
      3 : WriteLn('  Found monohrome display');
     end;
     a:=0;
     for b:=0 to 3 do if MemW[0:$400+b shl 2]<>0 then inc(a);
     WriteLn('  Found ',a,' serial port(s)');
     a:=0;
     for b:=0 to 3 do if MemW[0:$408+b shl 2]<>0 then inc(a);
     WriteLn('  Found ',a,' parallel port(s)');
     SetNumLock(True);WriteLn('  Num Lock is setting On');
  end else
    begin
     WriteLn('  computer IBM XT : ');
     a:=MemW[0:$410];
     if a and 1<>0 then WriteLn('  Found ',(a shr 6)and 3,' floppy disk(s)');
     if a and 2<>0 then WriteLn('  Found co-processor');
     if a and 12<>0 then WriteLn('  Base Memory 64k');
     case (a shr 4)and 3 of
      0 : WriteLn('  Found adapter EGA/VGA');
      1 : WriteLn('  Found color adapter 40x25');
      2 : WriteLn('  Found color adapter 80x25');
      3 : WriteLn('  Found monohrome display');
     end;
     WriteLn('  Found ',(a shr 9) and 7,' channal(s)');
     if (a shr 112) and 1<>0 then WriteLn('  Found gameport');
     if (a shr 14)<>0 then WriteLn('  Found ',(a shr 14),' printer(s)');
     SetNumLock(True);WriteLn('  Num Lock is setting On');
    end;
   {                            analise memory                               }
   Write('Analising memory ');
   for a:=1 to 6 do begin Write('.');Delay(Temp);end;WriteLn;
   if (Mem[$F000:$FFFE] = $FC)then
    begin
     Port[$70]:=$15;
     m:=Port[$71];
     Port[$70]:=$16;
     m:=m+Port[$71] shl 8;
     Port[$70]:=$17;
     e:=Port[$71];
     Port[$70]:=$18;
     e:=e+Port[$71] shl 8;
    end else
    begin
     e:=0;
     m:=1;
     for k:=1 to 9 do
      begin
       j:=k shl 12;
       if Mem[j:0]<>233 then Inc(m) else
        begin
         Mem[j:0]:=0;
         if (Mem[j:0]=0) then
          begin
           Inc(m);
           Mem[j:0]:=233;
          end;
        end;
      end;
      m:=m*64;
    end;
    WriteLn('  Found ',m,'k Base memory');
    if (e<>0) then WriteLn('  Found ',e,'k Extended memory');
    WriteLn('  Free DOS memory : ',memavail);
    WriteLn('  Total size of current disk ',DiskSize(0) div 1024,'K');
    WriteLn('  Free memory on current disk ',DiskFree(0) div 1024,'K');
   {                            analise OS                                   }
   Write('Analising OS ');
   for a:=1 to 6 do begin Write('.');Delay(Temp);end;WriteLn;
   r.ah:=$30;
   MSDOS(r);
   WriteLn('  Detected Dos version ',r.al,'.',r.ah);
   {                            analise speed                                }
{   Write('Analising CPU productivity ');
   for a:=1 to 6 do begin Write('.');Delay(Random(500)+100);end;WriteLn;
   k:=0;
   j:=integer(j);
   k:=longint(k);
   for j:=1 to 10 do
    begin
     Time:=MemL[0:$046C];
     while MemL[0:$046C]=Time do;
     inc(Time,2);
     while MemL[0:$046C]<>Time do inc(k);
    end;
   WriteLn('  ',k div 10);}
   {                       checking *.chr* *.bgi* files                      }
   Write('Analising file present ');
   for a:=1 to 6 do begin Write('.');Delay(Temp);end;WriteLn;
   for j:=1 to n do
    begin
     if (FilePresent(Files[j])=False)then
      begin
       WriteLn('  File ',files[j],' not found');
       WriteLn('  Aborting ...');
       Delay(5000);
       Halt;
      end;
    end;
   WriteLn('  All files found');
   {                       waiting if rshift pressed                         }
   Write('Analising RShift state ');
   for a:=1 to 6 do begin Write('.');Delay(Temp);end;WriteLn;
   if RightShiftDown then WriteLn('  RShift pressed ... Waiting') else
   WriteLn('  RShift unpressd');
   while RightShiftDown do;
   ClrScr;
 end;
{}
 Procedure SnowGo;
  type
   snow = record
           x,y : integer;
           speed : integer;
          end;
  const
   n = 200;
   s : byte = 3;
  var
   a : array [1..n] of snow;
   i,j : integer;
   {}
    procedure out(color : byte);
     var
      i : integer;
     begin
      for i:=1 to n do
       begin
        putpixel(a[i].x,a[i].y,color);
       end;
     end;
   {}
    procedure scanningpixels;
     var
      i,j : integer;
     begin
      for i:=1 to n do
       begin
        a[i].y:=a[i].y+a[i].speed;
        for j:=a[i].y-a[i].speed to a[i].y do
         begin
          if (getpixel(a[i].x,j)<>0)then
           begin
            putpixel(a[i].x,j-1,15);
            putpixel(a[i].x-1,j-1,15);
            putpixel(a[i].x+1,j-1,15);
            putpixel(a[i].x,j-2,15);
            a[i].y:=GetMaxY+1;
            Break;
           end;
         end;
        if (a[i].y>=getmaxx)then
         begin
          a[i].x:=Random(GetMaxX);
          a[i].y:=-1;a[i].speed:=Random(s)+1;
         end;
       end;
     end;
   {}
  begin
   Randomize;
   for i:=1 to n do
    begin
     a[i].x:=Random(GetMaxX);
     a[i].y:=Random(GetMaxY-25);
     a[i].speed:=Random(s)+1;
    end;
   repeat
    out(15);
    delay(190);
    out(0);
    scanningpixels;
   until keypressed;
  end;
{}
 Procedure ClearBuffer;assembler;
  asm
   CLI
   SUB AX,AX
   MOV ES,AX
   MOV AL,ES:[41AH]
   MOV ES:[41AH],AL
   STI
  end;
{}
End.